<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">

    <title>Kubernetes</title>

    <meta name="description" content="Kubernetes">
    <meta name="author" content="John Kristensen">

    <!-- https://github.com/hakimel/reveal.js/tree/master/css/... -->
    <link rel="stylesheet" href="css/reveal-3.4.1.css">
    <link rel="stylesheet" href="css/theme/black-3.4.1.css">
    <!-- Code syntax highlighting -->
    <!-- https://github.com/isagalaev/highlight.js/tree/master/src/styles/... -->
    <link rel="stylesheet" href="lib/css/zenburn-9.9.0.css">
    <style>
      .reveal section img {
        border: none;
      }
      .reveal section.text-left p {
        text-align: left;
      }
      .reveal section pre code {
        background: #343434;
        max-height: none;
        font-size: 19px;
        line-height: 1.2em;
      }

      .reveal section svg,
      .reveal section img {
        background-color: white;
        border-radius: 7px;
      }
      .reveal section svg {
        max-height: 550px;
      }
      .reveal section img {
        max-height: 400px;
      }

      /* Font used in SVGs */
      @font-face {
        font-family: 'Gloria Hallelujah';
        font-style: normal;
        font-weight: 400;
        src: local('Gloria Hallelujah'), local('GloriaHallelujah'),
             url(lib/font/gloria-hallelujah/GloriaHallelujah.woff2) format('woff2');
        unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2212, U+2215;
      }
    </style>
  </head>
  <body>
    <div class="reveal">
      <div class="slides">
        <section>
          <img src="images/kubernetes_logo_name.svg">

          <hr />

          John Kristensen (@jerrykan)
        </section>

        <section id="kubernetes" data-markdown>
          ## Kubernetes?
        </section>

        <section id="containers">
          <br>
          <br>

          <h2>Containers?</h2>

          <br>
          <br>

          <small>
            <a href="https://github.com/opencontainers/image-spec/blob/master/spec.md">
              https://github.com/opencontainers/image-spec/blob/master/spec.md
            </a>
            </small>
        </section>

        <section id="pods">
          <br>
          <br>

          <h2>Pods?</h2>

          <br>
          <br>

          <small>
            <a href="https://kubernetes.io/docs/concepts/workloads/pods/pod-overview/">
              https://kubernetes.io/docs/concepts/workloads/pods/pod-overview/
            </a>
          </small>
        </section>

        <section id="pod-manifest">
          <h4>Pod Manifest</h4>

          <pre><code class="hljs yaml" data-external="./_manifests/pod-taslug-demo-webapp.yaml"></code></pre>

          <br>

          <small>
            <a href="https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.16/#pod-v1-core">
              https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.16/#pod-v1-core
            </a>
          </small>
        </section>

        <section id="pod-create" data-markdown>
          *Demo: creating a pod*

          Note:
            ```
            $ kubectl create -f _manifests/pod-taslug-demo-webapp.yaml
            $ kubectl get pods
            $ curl 192.168.99.100:30000
            ```

        </section>

        <section id="kubernetes-pod-create">
          <svg viewBox="0 0 170 170">
            <use xlink:href="images/kubernetes.svg#etcd"></use>
            <use xlink:href="images/kubernetes.svg#apiserver" class="fragment"
                  data-fragment-index="1"></use>
            <use xlink:href="images/kubernetes.svg#minions" class="fragment"
                  data-fragment-index="2"></use>
            <use xlink:href="images/kubernetes.svg#user" class="fragment"
                  data-fragment-index="3"></use>
            <use xlink:href="images/kubernetes.svg#scheduler" class="fragment"
                  data-fragment-index="4"></use>
            <use xlink:href="images/kubernetes.svg#pod-action" class="fragment"
                  data-fragment-index="5"></use>
            <use xlink:href="images/kubernetes.svg#pod-new" class="fragment"
                  data-fragment-index="5"></use>
          </svg>
        </section>

        <section id="pod-delete" data-markdown>
          *Demo: deleting a pod*

          Note:
            ```
            $ kubectl delete pod taslug-demo-webapp
            $ kubectl get pods
            $ curl 192.168.99.100:30000

            ```
        </section>

        <section id="kubernetes-pod-delete">
          <svg viewBox="0 0 170 170">
            <use xlink:href="images/kubernetes.svg#etcd"></use>
            <use xlink:href="images/kubernetes.svg#apiserver"></use>
            <use xlink:href="images/kubernetes.svg#minions"></use>
            <use xlink:href="images/kubernetes.svg#pod"></use>
            <use xlink:href="images/kubernetes.svg#user" class="fragment"
                  data-fragment-index="1"></use>
            <use xlink:href="images/kubernetes.svg#pod-action" class="fragment"
                  data-fragment-index="2"></use>
            <use xlink:href="images/kubernetes.svg#pod-delete" class="fragment"
                  data-fragment-index="2"></use>
          </svg>
        </section>

        <section id="deployments">
          <br>
          <br>

          <h2>Deployments?</h2>

          <br>
          <br>

          <small>
            <a href="https://kubernetes.io/docs/concepts/workloads/controllers/deployment/">
              https://kubernetes.io/docs/concepts/workloads/controllers/deployment/
            </a>
          </small>
        </section>

        <section id="deployment-manifest">
          <h4>Deployment Manifest</h4>
          <pre><code class="hljs yaml" data-external="./_manifests/deployment-taslug-demo-webapp.yaml"></code></pre>
        </section>

        <section id="deployment-create" data-markdown>
          *Demo: creating a deployment*

          Note:
            ```
            $ kubectl create -f _manifests/deployment-hello-minikube.yaml
            $ kubectl get pods
            $ curl 192.168.99.100:30000

            # increase replicas
            $ kubectl edit deployment taslug-demo-webapp
            $ kubectl get pods

            # decrease replicas
            $ kubectl edit deployment taslug-demo-webapp
            $ kubectl get pods

            $ kubectl delete pod taslug-demo-webapp-***-***
            $ kubectl get pods

            # edit labels
            $ kubectl edit pod taslug-demo-webapp-***-***
            $ kubectl get pods
            # delete faulty pod
            $ kubectl delete pod taslug-demo-webapp-***-***
            $ kubectl get pods
            ```
        </section>

        <section id="kubernetes-deployment-controller">
          <svg viewBox="0 0 170 170">
            <use xlink:href="images/kubernetes.svg#etcd"></use>
            <use xlink:href="images/kubernetes.svg#apiserver"></use>
            <use xlink:href="images/kubernetes.svg#minions"></use>
            <use xlink:href="images/kubernetes.svg#user" class="fragment"
                  data-fragment-index="1"></use>
            <use xlink:href="images/kubernetes.svg#controller" class="fragment"
                  data-fragment-index="2"></use>
            <use xlink:href="images/kubernetes.svg#scheduler" class="fragment"
                  data-fragment-index="3"></use>
            <use xlink:href="images/kubernetes.svg#pod-action" class="fragment"
                  data-fragment-index="4"></use>
            <use xlink:href="images/kubernetes.svg#pod-new" class="fragment"
                  data-fragment-index="4"></use>
            <use xlink:href="images/kubernetes.svg#deploy-pod" class="fragment"
                  data-fragment-index="4"></use>
          </svg>
        </section>

        <section id="deployment-rollout" data-markdown>
          *Demo: rollout new containers*

          Note:
            ```
            # update container -> :v2
            $ kubectl edit deployment taslug-demo-webapp
            $ kubectl get pods
            $ curl 192.168.99.100:30000
            ```
        </section>

        <section id="questions" data-markdown>
          ## Questions?
        </section>
      </div>
    </div>

    <!-- http://headjs.com/site/download.html -->
    <script src="lib/js/head-1.0.3.min.js"></script>
    <!-- https://github.com/hakimel/reveal.js/blob/master/js/reveal.js -->
    <script src="js/reveal-3.4.1.js"></script>
    <script>
      Reveal.initialize({
        transition: 'none',
        slideNumber: true,

        dependencies: [
          {
            // https://github.com/janschoepke/reveal_external/blob/master/external/external.js
            src: 'plugin/external/external-1.3.js',
            condition: function() {
              return !!document.querySelector('[data-external],[data-external-replace]');
            },
          },
          // Interpret Markdown in <section> elements
          {
            // https://github.com/chjj/marked/blob/master/marked.min.js
            src: 'plugin/markdown/marked-0.3.6.min.js',
            condition: function() {
              return !!document.querySelector( '[data-markdown]' );
            },
          }, {
            // https://github.com/hakimel/reveal.js/blob/master/plugin/markdown/markdown.js
            src: 'plugin/markdown/markdown-3.4.1-ea1dcbbf1e.js',
            condition: function() {
              return !!document.querySelector( '[data-markdown]' );
            }
          },
          // Code highlighting
          {
            // taken from https://github.com/hakimel/reveal.js/blob/master/plugin/highlight/highlight.js
            src: 'plugin/highlight/highlight-reveal-shim-3.5.0.js',
            async: true,
          },
          {
            // https://highlightjs.org/download/
            src: 'plugin/highlight/highlight-9.12.0-common.pack.js',
            async: true,
            callback: function() {
              hljs.initHighlightingOnLoad();
            }
          },
          // Speaker notes
          {
            // https://github.com/hakimel/reveal.js/blob/master/plugin/notes/notes.js
            src: 'plugin/notes/notes-3.4.1.js',
            async: true
          }
        ]
      });
    </script>
  </body>
</html>
